Index: /LMDZ6/trunk/libf/dyn3dmem/advtrac_loc.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/advtrac_loc.F90	(revision 4056)
+++ /LMDZ6/trunk/libf/dyn3dmem/advtrac_loc.F90	(revision 4056)
@@ -0,0 +1,290 @@
+
+#define DEBUG_IO
+#undef DEBUG_IO
+SUBROUTINE advtrac_loc(pbarug, pbarvg, wg, p, massem, q, teta, pk)
+   !     Auteur :  F. Hourdin
+   !
+   !     Modif. P. Le Van     (20/12/97)
+   !            F. Codron     (10/99)
+   !            D. Le Croller (07/2001)
+   !            M.A Filiberti (04/2002)
+   !
+   USE infotrac,     ONLY: nqtot, tracers,ok_iso_verif
+   USE control_mod,  ONLY: iapp_tracvl, day_step, planet_type
+   USE comconst_mod, ONLY: dtvr
+   USE parallel_lmdz
+   USE Write_Field_loc
+   USE Write_Field
+   USE Bands
+   USE mod_hallo
+   USE Vampir
+   USE times
+   USE advtrac_mod, ONLY: finmasse
+
+   IMPLICIT NONE
+   !
+   include "dimensions.h"
+   include "paramet.h"
+   include "comdissip.h"
+   include "comgeom2.h"
+   include "description.h"
+!   include "iniprint.h"
+
+   !---------------------------------------------------------------------------
+   !     Arguments
+   !---------------------------------------------------------------------------
+   REAL, INTENT(IN) ::  pbarug(ijb_u:ije_u,llm)
+   REAL, INTENT(IN) ::  pbarvg(ijb_v:ije_v,llm)
+   REAL, INTENT(IN) ::      wg(ijb_u:ije_u,llm)
+   REAL, INTENT(IN) ::       p(ijb_u:ije_u,llmp1)
+   REAL, INTENT(IN) ::  massem(ijb_u:ije_u,llm)
+   REAL, INTENT(INOUT) ::    q(ijb_u:ije_u,llm,nqtot)
+   REAL, INTENT(IN) ::    teta(ijb_u:ije_u,llm)
+   REAL, INTENT(IN) ::      pk(ijb_u:ije_u,llm)
+   !---------------------------------------------------------------------------
+   !     Ajout PPM
+   !---------------------------------------------------------------------------
+   REAL :: massebx(ijb_u:ije_u,llm), masseby(ijb_v:ije_v,llm)
+   !---------------------------------------------------------------------------
+   !     Variables locales
+   !---------------------------------------------------------------------------
+   INTEGER :: ij, l, iq, iiq, iadv
+   REAL(KIND=KIND(1.d0)) :: t_initial, t_final, tps_cpu
+   REAL :: zdp(ijb_u:ije_u), zdpmin, zdpmax
+   INTEGER, SAVE :: iadvtr=0
+!$OMP THREADPRIVATE(iadvtr)
+   EXTERNAL  minmax
+
+   !---------------------------------------------------------------------------
+   !     Rajouts pour PPM
+   !---------------------------------------------------------------------------
+   INTEGER :: indice, n
+   REAL :: dtbon                       ! Pas de temps adaptatif pour que CFL<1
+   REAL :: CFLmaxz, aaa, bbb           ! CFL maximum
+   REAL, DIMENSION(iim,jjb_u:jje_u,llm) :: unatppm, vnatppm, fluxwppm
+   REAL ::    qppm(iim*jjnb_u,llm,nqtot)
+   REAL ::   psppm(iim,jjb_u:jje_u)    ! pression  au sol
+   REAL, DIMENSION(llmp1) :: apppm, bpppm
+   LOGICAL, SAVE :: dum=.TRUE., fill=.TRUE.
+   INTEGER :: ijb, ije, ijbu, ijbv, ijeu, ijev, j
+   TYPE(Request),SAVE :: testRequest
+!$OMP THREADPRIVATE(testRequest)
+
+! Test sur l'eventuelle creation de valeurs negatives de la masse
+   ijb = ij_begin; IF(pole_nord) ijb = ij_begin+iip1
+   ije = ij_end;   IF(pole_sud)  ije = ij_end-iip1
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+   DO l=1,llm-1
+      DO ij = ijb+1,ije
+         zdp(ij) = pbarug(ij-1,l)    - pbarug(ij,l) &
+                 - pbarvg(ij-iip1,l) + pbarvg(ij,l) &
+                 +     wg(ij,l+1)    -     wg(ij,l)
+      END DO
+! ym  ---> pourquoi jjm-1 et non jjm ? a cause du pole ?
+!     CALL SCOPY( jjm -1 ,zdp(iip1+iip1),iip1,zdp(iip2),iip1 )
+      DO ij = ijb,ije-iip1+1,iip1
+         zdp(ij)=zdp(ij+iip1-1)
+      END DO
+      DO ij = ijb,ije
+         zdp(ij)= zdp(ij)*dtvr/ massem(ij,l) 
+      END DO 
+!     CALL minmax ( ip1jm-iip1, zdp(iip2), zdpmin,zdpmax )
+! ym ---> eventuellement a revoir
+      CALL minmax( ije-ijb+1, zdp(ijb), zdpmin,zdpmax )
+      IF(MAX(ABS(zdpmin),ABS(zdpmax)) >0.5) &
+         WRITE(*,*)'WARNING DP/P l=',l,'  MIN:',zdpmin,'   MAX:', zdpmax
+   END DO
+!$OMP END DO NOWAIT
+
+   !---------------------------------------------------------------------------
+   !   Advection proprement dite (Modification Le Croller (07/2001)
+   !---------------------------------------------------------------------------
+
+   !---------------------------------------------------------------------------
+   !   Calcul des moyennes basees sur la masse
+   !---------------------------------------------------------------------------
+!ym   CALL massbar_p(massem,massebx,masseby)
+!ym   ----> Normalement, inutile pour les schémas classiques
+!ym   ----> Revérifier lors de la parallélisation des autres schemas
+
+#ifdef DEBUG_IO    
+   CALL WriteField_u('massem',massem)
+   CALL WriteField_u('wg',wg)
+   CALL WriteField_u('pbarug',pbarug)
+   CALL WriteField_v('pbarvg',pbarvg)
+   CALL WriteField_u('p_tmp',p)
+   CALL WriteField_u('pk_tmp',pk)
+   CALL WriteField_u('teta_tmp',teta)
+   DO iq=1,nqtot
+      CALL WriteField_u('q_adv'//trim(int2str(iq)),q(:,:,iq))
+   END DO
+#endif
+
+!          
+!  CALL Register_Hallo_v(pbarvg,llm,1,1,1,1,TestRequest)
+!  CALL SendRequest(TestRequest)
+!!$OMP BARRIER
+!  CALL WaitRequest(TestRequest)
+!$OMP BARRIER
+                 
+!  WRITE(*,*) 'advtrac 157: appel de vlspltgen_loc'
+   CALL vlspltgen_loc(q, tracers(:)%iadv, 2., massem, wg, pbarug, pbarvg, dtvr, p, pk, teta )
+
+#ifdef DEBUG_IO     
+   DO iq = 1, nqtot
+      CALL WriteField_u('q_adv'//trim(int2str(iq)),q(:,:,iq))
+   END DO
+#endif
+         
+   GOTO 1234     
+   !-------------------------------------------------------------------------
+   !       Appel des sous programmes d'advection
+   !-------------------------------------------------------------------------
+   DO iq = 1, nqtot
+!     CALL clock(t_initial)
+      IF(tracers(iq)%parent /= 'air') CYCLE
+      iadv = tracers(iq)%iadv
+      !-----------------------------------------------------------------------
+      SELECT CASE(iadv)
+      !-----------------------------------------------------------------------
+         CASE(0); CYCLE
+         !--------------------------------------------------------------------
+         CASE(10)  !--- Schema de Van Leer I MUSCL
+         !--------------------------------------------------------------------
+!           WRITE(*,*) 'advtrac 239: iq,q(1721,19,:)=',iq,q(1721,19,:)     
+!LF         CALL vlsplt_p(q(1,1,iq),2.,massem,wg,pbarug,pbarvg,dtvr)
+
+         !--------------------------------------------------------------------
+         CASE(14)  !--- Schema "pseuDO amont" + test sur humidite specifique
+                   !--- pour la vapeur d'eau. F. Codron
+         !--------------------------------------------------------------------
+!           WRITE(*,*) 'advtrac 248: iq,q(1721,19,:)=',iq,q(1721,19,:)
+            STOP 'advtrac : appel a vlspltqs :schema non parallelise'
+!LF         CALL vlspltqs_p(q(1,1,1),2.,massem,wg,pbarug,pbarvg,dtvr,p,pk,teta )
+
+         !--------------------------------------------------------------------
+         CASE(12)  !--- Schema de Frederic Hourdin
+         !--------------------------------------------------------------------
+            CALL adaptdt(iadv,dtbon,n,pbarug,massem)   ! pas de temps adaptatif
+            IF(n > 1) WRITE(*,*) 'WARNING horizontal dt=',dtbon,'dtvr=',dtvr,'n=',n
+            DO indice=1,n
+              CALL advn(q(1,1,iq),massem,wg,pbarug,pbarvg,dtbon,1)
+            END DO
+
+         !--------------------------------------------------------------------
+         CASE(13)  !--- Pas de temps adaptatif
+         !--------------------------------------------------------------------
+            STOP 'advtrac : schema non parallelise'
+            CALL adaptdt(iadv,dtbon,n,pbarug,massem)
+            IF(n > 1) WRITE(*,*) 'WARNING horizontal dt=',dtbon,'dtvr=',dtvr,'n=',n
+            DO indice=1,n
+               CALL advn(q(1,1,iq),massem,wg,pbarug,pbarvg,dtbon,2)
+            END DO
+
+         !--------------------------------------------------------------------
+         CASE(20)  !--- Schema de pente SLOPES
+         !--------------------------------------------------------------------
+            STOP 'advtrac : schema non parallelise'
+            CALL pentes_ini (q(1,1,iq),wg,massem,pbarug,pbarvg,0)
+
+         !--------------------------------------------------------------------
+         CASE(30)  !--- Schema de Prather
+         !--------------------------------------------------------------------
+            STOP 'advtrac : schema non parallelise'
+            ! Pas de temps adaptatif
+            CALL adaptdt(iadv,dtbon,n,pbarug,massem)
+            IF(n > 1) WRITE(*,*) 'WARNING horizontal dt=',dtbon,'dtvr=',dtvr,'n=',n
+            CALL prather(q(1,1,iq),wg,massem,pbarug,pbarvg,n,dtbon)
+
+         !--------------------------------------------------------------------
+         CASE(11,16,17,18)   !--- Schemas PPM Lin et Rood
+         !--------------------------------------------------------------------
+     	    STOP 'advtrac : schema non parallelise'
+            ! Test sur le flux horizontal
+            CALL adaptdt(iadv,dtbon,n,pbarug,massem)   ! pas de temps adaptatif
+            IF(n > 1) WRITE(*,*) 'WARNING horizontal dt=',dtbon,'dtvr=',dtvr,'n=',n
+            ! Test sur le flux vertical
+            CFLmaxz=0.
+            DO l=2,llm
+               DO ij=iip2,ip1jm
+                  aaa=wg(ij,l)*dtvr/massem(ij,l)
+                  CFLmaxz=max(CFLmaxz,aaa)
+                  bbb=-wg(ij,l)*dtvr/massem(ij,l-1)
+                  CFLmaxz=max(CFLmaxz,bbb)
+               END DO
+            END DO
+            IF(CFLmaxz.GE.1) WRITE(*,*) 'WARNING vertical','CFLmaxz=', CFLmaxz
+            !----------------------------------------------------------------
+            !     Ss-prg interface LMDZ.4->PPM3d (ss-prg de Lin)
+            !----------------------------------------------------------------
+            CALL interpre(q(1,1,iq),qppm(1,1,iq),wg,fluxwppm,massem, &
+                 apppm,bpppm,massebx,masseby,pbarug,pbarvg, &
+                 unatppm,vnatppm,psppm)
+
+            !----------------------------------------------------------------
+            DO indice=1,n     !--- VL (version PPM) horiz. et PPM vert.
+            !----------------------------------------------------------------
+               SELECT CASE(iadv)
+                  !----------------------------------------------------------
+                  CASE(11)
+                  !----------------------------------------------------------
+                     CALL ppm3d(1,qppm(1,1,iq),psppm,psppm,unatppm,vnatppm,fluxwppm,dtbon, &
+                                2,2,2,1,iim,jjp1,2,llm,apppm,bpppm,0.01,6400000,fill,dum,220.)
+                  !----------------------------------------------------------
+                  CASE(16) !--- Monotonic PPM
+                  !----------------------------------------------------------
+                     CALL ppm3d(1,qppm(1,1,iq),psppm,psppm,unatppm,vnatppm,fluxwppm,dtbon, &
+                                3,3,3,1,iim,jjp1,2,llm,apppm,bpppm,0.01,6400000,fill,dum,220.)
+                  !----------------------------------------------------------
+                  CASE(17) !--- Semi monotonic PPM
+                  !----------------------------------------------------------
+                     CALL ppm3d(1,qppm(1,1,iq),psppm,psppm,unatppm,vnatppm,fluxwppm,dtbon, &
+                                4,4,4,1,iim,jjp1,2,llm,apppm,bpppm,0.01,6400000, fill,dum,220.)
+                  !----------------------------------------------------------
+                  CASE(18) !--- Positive Definite PPM
+                  !----------------------------------------------------------
+                     CALL ppm3d(1,qppm(1,1,iq),psppm,psppm,unatppm,vnatppm,fluxwppm,dtbon, &
+                                5,5,5,1,iim,jjp1,2,llm,apppm,bpppm,0.01,6400000,fill,dum,220.)
+               END SELECT
+            !----------------------------------------------------------------
+            END DO
+            !----------------------------------------------------------------
+            !     Ss-prg interface PPM3d-LMDZ.4
+            !----------------------------------------------------------------
+            CALL interpost(q(1,1,iq),qppm(1,1,iq))
+      !----------------------------------------------------------------------
+      END SELECT
+      !----------------------------------------------------------------------
+
+      !----------------------------------------------------------------------
+      ! On impose une seule valeur du traceur au pôle Sud j=jjm+1=jjp1 et Nord j=1
+      !----------------------------------------------------------------------
+      !  CALL traceurpole(q(1,1,iq),massem)
+
+      !--- Calcul du temps cpu pour un schema donne
+      !  CALL clock(t_final)
+      !ym  tps_cpu=t_final-t_initial
+      !ym  cpuadv(iq)=cpuadv(iq)+tps_cpu
+
+   END DO
+
+1234 CONTINUE
+!$OMP BARRIER
+   IF(planet_type=="earth") THEN
+      ijb=ij_begin
+      ije=ij_end
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      DO l = 1, llm
+         DO ij = ijb, ije
+            finmasse(ij,l) =  p(ij,l) - p(ij,l+1) 
+         END DO
+      END DO
+!$OMP END DO
+
+      CALL qminimum_loc( q, nqtot, finmasse )
+
+   END IF ! of if (planet_type=="earth")
+
+END SUBROUTINE advtrac_loc
+
Index: /LMDZ6/trunk/libf/dyn3dmem/call_calfis_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/call_calfis_mod.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/dyn3dmem/call_calfis_mod.F90	(revision 4056)
@@ -113,5 +113,5 @@
     TYPE(Request),SAVE :: Request_physic
 !$OMP THREADPRIVATE(Request_physic )
-    INTEGER :: ijb,ije,l,j
+    INTEGER :: ijb,ije,l,iq
     
     
@@ -122,6 +122,6 @@
     CALL WriteField_u('pfi',p)
     CALL WriteField_u('pkfi',pk)
-    DO j=1,nqtot
-      CALL WriteField_u('qfi'//trim(int2str(j)),q(:,:,j))
+    DO iq=1,nqtot
+      CALL WriteField_u('qfi'//trim(int2str(iq)),q(:,:,iq))
     ENDDO
 #endif
@@ -223,6 +223,6 @@
     CALL WriteField_u('pfi',p)
     CALL WriteField_u('pkfi',pk)
-    DO j=1,nqtot
-      CALL WriteField_u('qfi'//trim(int2str(j)),q(:,:,j))
+    DO iq=1,nqtot
+      CALL WriteField_u('qfi'//trim(int2str(iq)),q(:,:,iq))
     ENDDO
 #endif
@@ -267,6 +267,6 @@
     CALL Register_Hallo_u(dpfi,1,1,0,0,1,Request_physic)
 
-    DO j=1,nqtot
-      CALL Register_Hallo_u(dqfi(:,:,j),llm,1,0,0,1,Request_physic)
+    DO iq=1,nqtot
+      CALL Register_Hallo_u(dqfi(:,:,iq),llm,1,0,0,1,Request_physic)
     ENDDO
         
@@ -305,6 +305,6 @@
     CALL WriteField_u('dtetafi',dtetafi)
     CALL WriteField_u('dpfi',dpfi)
-    DO j=1,nqtot
-      CALL WriteField_u('dqfi'//trim(int2str(j)),dqfi(:,:,j))
+    DO iq=1,nqtot
+      CALL WriteField_u('dqfi'//trim(int2str(iq)),dqfi(:,:,iq))
     ENDDO
 #endif
@@ -319,6 +319,6 @@
     CALL WriteField_u('tetafi',teta)
     CALL WriteField_u('psfi',ps)
-    DO j=1,nqtot
-      CALL WriteField_u('qfi'//trim(int2str(j)),q(:,:,j))
+    DO iq=1,nqtot
+      CALL WriteField_u('qfi'//trim(int2str(iq)),q(:,:,iq))
     ENDDO
 #endif
@@ -329,6 +329,6 @@
     CALL WriteField_u('tetafi',teta)
     CALL WriteField_u('psfi',ps)
-    DO j=1,nqtot
-      CALL WriteField_u('qfi'//trim(int2str(j)),q(:,:,j))
+    DO iq=1,nqtot
+      CALL WriteField_u('qfi'//trim(int2str(iq)),q(:,:,iq))
     ENDDO
 #endif
@@ -354,6 +354,6 @@
     CALL WriteField_u('tetafi',teta)
     CALL WriteField_u('psfi',ps)
-    DO j=1,nqtot
-      CALL WriteField_u('qfi'//trim(int2str(j)),q(:,:,j))
+    DO iq=1,nqtot
+      CALL WriteField_u('qfi'//trim(int2str(iq)),q(:,:,iq))
     ENDDO
 #endif
@@ -401,6 +401,6 @@
     CALL WriteField_u('tetafi',teta_dyn)
     CALL WriteField_u('psfi',ps_dyn)
-    DO j=1,nqtot
-      CALL WriteField_u('qfi'//trim(int2str(j)),q_dyn(:,:,j))
+    DO iq=1,nqtot
+      CALL WriteField_u('qfi'//trim(int2str(iq)),q_dyn(:,:,iq))
     ENDDO
 #endif
Index: /LMDZ6/trunk/libf/dyn3dmem/iniacademic_loc.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/iniacademic_loc.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/dyn3dmem/iniacademic_loc.F90	(revision 4056)
@@ -5,9 +5,9 @@
 
   USE filtreg_mod, ONLY: inifilr
+  USE infotrac,    ONLY: nqtot, niso_possibles, ok_isotopes, ok_iso_verif, tnat, alpha_ideal, &
+                         iqiso, tracers, iso_indnum
+  USE control_mod, ONLY: day_step,planet_type
   use exner_hyb_m, only: exner_hyb
   use exner_milieu_m, only: exner_milieu
-  USE infotrac, ONLY: nqtot, niso_possibles, ok_isotopes, ok_iso_verif, tnat, alpha_ideal, &
-                      iqiso, tracers, iso_indnum
-  USE control_mod, ONLY: day_step,planet_type
   USE parallel_lmdz, ONLY: ijb_u, ije_u, ijb_v, ije_v
 #ifdef CPP_IOIPSL
@@ -23,5 +23,4 @@
   USE temps_mod, ONLY: annee_ref, day_ini, day_ref
   USE ener_mod, ONLY: etot0,ptot0,ztot0,stot0,ang0
-
 
   !   Author:    Frederic Hourdin      original: 15/01/93
@@ -112,5 +111,5 @@
   ztot0      = 0.
   stot0      = 0.
-  ang0       = 0.      
+  ang0       = 0.
 
   if (llm == 1) then
@@ -143,8 +142,7 @@
         ps_glo(:)=preff
      endif
-     
+
      ! ground geopotential
      phis_glo(:)=0.
-
      CALL pression ( ip1jmp1, ap, bp, ps_glo, p       )
      if (pressure_exner) then
@@ -155,5 +153,4 @@
      CALL massdair(p,masse_glo)
   ENDIF
-
 
   if (llm == 1) then
@@ -281,11 +278,10 @@
         if (planet_type=="earth") then
            ! Earth: first two tracers will be water
-
            do iq=1,nqtot
               q(ijb_u:ije_u,:,iq)=0.
-!              IF(tracers(iq)%name == 'H2O'//Phases_sep//'g') q(ijb_u:ije_u,:,iq)=1.e-10
+!              IF(tracers(iq)%name == 'H2O'//phases_sep//'g') q(ijb_u:ije_u,:,iq)=1.e-10
 !              IF(tracers(iq)%name == 'H2O'//phases_sep//'l') q(ijb_u:ije_u,:,iq)=1.e-15
-              if (tracers(iq)%name == 'H2Ov') q(ijb_u:ije_u,:,iq)=1.e-10
-              if (tracers(iq)%name == 'H2Ol') q(ijb_u:ije_u,:,iq)=1.e-15
+              IF(tracers(iq)%name == 'H2Ov') q(ijb_u:ije_u,:,iq)=1.e-10
+              IF(tracers(iq)%name == 'H2Ol') q(ijb_u:ije_u,:,iq)=1.e-15
 
               ! CRisi: init des isotopes
@@ -293,6 +289,6 @@
               iName = tracers(iq)%iso_iName
               if (.NOT.ok_isotopes .OR. iName <= 0) CYCLE
-              iZone = tracers(iq)%iso_iZone
-              iPhase= tracers(iq)%iso_iPhase
+              iZone    = tracers(iq)%iso_iZone
+              iPhase   = tracers(iq)%iso_iPhase
               iqParent = tracers(iq)%iqParent
               if (iZone == 0) q(ijb_u:ije_u,:,iq) = q(ijb_u:ije_u,:,iqParent)*tnat(iName) &
@@ -304,7 +300,5 @@
         endif ! of if (planet_type=="earth")
 
-        if (ok_iso_verif) then
-           call check_isotopes(q,ijb_u,ije_u,'iniacademic_loc')
-        endif !if (ok_iso_verif) then
+        if (ok_iso_verif) call check_isotopes(q,ijb_u,ije_u,'iniacademic_loc')
 
         ! add random perturbation to temperature
Index: /LMDZ6/trunk/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/leapfrog_loc.F	(revision 4055)
+++ /LMDZ6/trunk/libf/dyn3dmem/leapfrog_loc.F	(revision 4056)
@@ -664,7 +664,7 @@
         call WriteField_u('pkf',pkf)
         call WriteField_u('phis',phis)
-        do j=1,nqtot
-          call WriteField_u('q'//trim(int2str(j)),
-     .                q(:,:,j))
+        do iq=1,nqtot
+          call WriteField_u('q'//trim(int2str(iq)),
+     .                q(:,:,iq))
         enddo
       endif
Index: /LMDZ6/trunk/libf/dyn3dmem/vlspltgen_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/vlspltgen_loc.F	(revision 4055)
+++ /LMDZ6/trunk/libf/dyn3dmem/vlspltgen_loc.F	(revision 4056)
@@ -28,5 +28,5 @@
       USE VAMPIR
       ! CRisi: on rajoute variables utiles d'infotrac  
-      USE infotrac, ONLY : nqtot,nqperes, tracers,ok_iso_verif
+      USE infotrac, ONLY : nqtot, tracers,ok_iso_verif
       USE vlspltgen_mod
       USE comconst_mod, ONLY: cpp
@@ -196,10 +196,11 @@
 
 c$OMP BARRIER           
-!      DO iq=1,nqtot
-      DO iq=1,nqperes ! CRisi: on ne boucle que sur les pères= ceux qui sont transportés directement par l'air
-       !write(*,*) 'vlspltgen 192: iq,iadv=',iq,tracers(iq)%iadv
+      DO iq=1,nqtot
+        ! CRisi: on ne boucle que sur les pères= ceux qui sont transportés directement par l'air
+        IF(tracers(iq)%parent /= 'air') CYCLE
+        !write(*,*) 'vlspltgen 192: iq,iadv=',iq,tracers(iq)%iadv
 #ifdef DEBUG_IO    
-       CALL WriteField_u('zq',zq(:,:,iq))
-       CALL WriteField_u('zm',zm(:,:,iq)) 
+        CALL WriteField_u('zq',zq(:,:,iq))
+        CALL WriteField_u('zm',zm(:,:,iq)) 
 #endif
         SELECT CASE(tracers(iq)%iadv)
@@ -264,5 +265,5 @@
         END SELECT
       
-      enddo !DO iq=1,nqperes
+      enddo !DO iq=1,nqtot
       
       
@@ -288,5 +289,6 @@
       endif !if (ok_iso_verif) then
 
-      do iq=1,nqperes
+      do iq=1,nqtot
+        IF(tracers(iq)%parent /= 'air') CYCLE
         !write(*,*) 'vlspltgen 279: iq=',iq
 
@@ -328,6 +330,4 @@
       if (ok_iso_verif) then
            call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 326')
-      endif !if (ok_iso_verif) then        
-      if (ok_iso_verif) then
            ijb=ij_begin-2*iip1
            ije=ij_end+2*iip1
@@ -337,5 +337,6 @@
       endif !if (ok_iso_verif) then  
 
-      do iq=1,nqperes
+      do iq = 1, nqtot
+       IF(tracers(iq)%parent /= 'air') CYCLE
        !write(*,*) 'vlspltgen 321: iq=',iq
 #ifdef DEBUG_IO    
@@ -358,5 +359,6 @@
       endif !if (ok_iso_verif) then
 
-      do iq=1,nqperes
+      do iq = 1, nqtot
+       IF(tracers(iq)%parent /= 'air') CYCLE
       !write(*,*) 'vlspltgen 349: iq=',iq
 #ifdef DEBUG_IO    
@@ -419,5 +421,6 @@
 
 c$OMP BARRIER
-      do iq=1,nqperes
+      do iq=1,nqtot
+        IF(tracers(iq)%parent /= 'air') CYCLE
       !write(*,*) 'vlspltgen 409: iq=',iq
 
@@ -462,5 +465,6 @@
       endif !if (ok_iso_verif) then
 
-      do iq=1,nqperes
+      do iq=1,nqtot
+        IF(tracers(iq)%parent /= 'air') CYCLE
       !write(*,*) 'vlspltgen 449: iq=',iq
 #ifdef DEBUG_IO    
@@ -475,5 +479,5 @@
         END SELECT
        
-       enddo !do iq=1,nqperes
+       enddo !do iq=1,nqtot
 
       if (ok_iso_verif) then
@@ -481,5 +485,6 @@
       endif !if (ok_iso_verif) then
 
-      do iq=1,nqperes
+      do iq=1,nqtot
+        IF(tracers(iq)%parent /= 'air') CYCLE
       !write(*,*) 'vlspltgen 477: iq=',iq
 #ifdef DEBUG_IO    
@@ -496,5 +501,5 @@
         END SELECT
        
-       enddo !do iq=1,nqperes
+       enddo !do iq=1,nqtot
 
       !write(*,*) 'vlspltgen 550: apres derniere serie de call vlx'
Index: /LMDZ6/trunk/libf/dynphy_lonlat/calfis.F
===================================================================
--- /LMDZ6/trunk/libf/dynphy_lonlat/calfis.F	(revision 4055)
+++ /LMDZ6/trunk/libf/dynphy_lonlat/calfis.F	(revision 4056)
@@ -29,5 +29,5 @@
 c    Auteur :  P. Le Van, F. Hourdin 
 c   .........
-      USE infotrac, ONLY: nqtot, niadv, tracers
+      USE infotrac, ONLY: nqtot, tracers
       USE control_mod, ONLY: planet_type, nsplit_phys
 #ifdef CPP_PHYS
@@ -135,5 +135,5 @@
 c    -----------------
 
-      INTEGER i,j,l,ig0,ig,iq,iiq
+      INTEGER i,j,l,ig0,ig,iq,itr
       REAL zpsrf(ngridmx)
       REAL zplev(ngridmx,llm+1),zplay(ngridmx,llm)
@@ -281,16 +281,18 @@
 c   ---------------
 c
+      itr=0
       DO iq=1,nqtot
-          iiq=niadv(iq) 
+         IF(.NOT.tracers(iq)%isAdvected) CYCLE
+         itr = itr + 1
          DO l=1,llm
-            zqfi(1,l,iq) = pq(1,1,l,iiq)
-            ig0          = 2
+            zqfi(1,l,itr) = pq(1,1,l,iq)
+            ig0           = 2
             DO j=2,jjm
                DO i = 1, iim
-                  zqfi(ig0,l,iq)  = pq(i,j,l,iiq)
+                  zqfi(ig0,l,itr) = pq(i,j,l,iq)
                   ig0             = ig0 + 1
                ENDDO
             ENDDO
-            zqfi(ig0,l,iq) = pq(1,jjp1,l,iiq)
+            zqfi(ig0,l,itr) = pq(1,jjp1,l,iq)
          ENDDO
       ENDDO
@@ -481,4 +483,5 @@
          lafin_split=lafin.and.isplit==nsplit_phys
 
+!      if (planet_type=="earth") then
         CALL call_physiq(ngridmx,llm,nqtot,tracers(:)%name,
      &                   debut_split,lafin_split,
@@ -490,30 +493,4 @@
      &                   flxwfi,pducov,
      &                   zdufi,zdvfi,zdtfi,zdqfi,zdpsrf)
-                             
-!      if (planet_type=="earth") then
-!
-!         CALL physiq (ngridmx,
-!     .             llm,
-!     .             debut_split,
-!     .             lafin_split,
-!     .             jD_cur,
-!     .             jH_cur_split,
-!     .             zdt_split,
-!     .             zplev,
-!     .             zplay,
-!     .             zphi,
-!     .             zphis,
-!     .             presnivs,
-!     .             zufi,
-!     .             zvfi, zrfi,
-!     .             ztfi,
-!     .             zqfi,
-!     .             flxwfi,
-!     .             zdufi,
-!     .             zdvfi,
-!     .             zdtfi,
-!     .             zdqfi,
-!     .             zdpsrf,
-!     .             pducov)
 !
 !      else if ( planet_type=="generic" ) then
@@ -622,17 +599,19 @@
       pdqfi(:,:,:,:)=0.
 C
+      itr = 0
       DO iq=1,nqtot
-         iiq=niadv(iq)
+         IF(.NOT.tracers(iq)%isAdvected) CYCLE
+         itr = itr + 1
          DO l=1,llm
             DO i=1,iip1
-               pdqfi(i,1,l,iiq)    = zdqfi(1,l,iq)
-               pdqfi(i,jjp1,l,iiq) = zdqfi(ngridmx,l,iq)
+               pdqfi(i,1,l,iq)    = zdqfi(1,l,itr)
+               pdqfi(i,jjp1,l,iq) = zdqfi(ngridmx,l,itr)
             ENDDO
             DO j=2,jjm
                ig0=1+(j-2)*iim
                DO i=1,iim
-                  pdqfi(i,j,l,iiq) = zdqfi(ig0+i,l,iq)
+                  pdqfi(i,j,l,iq) = zdqfi(ig0+i,l,itr)
                ENDDO
-               pdqfi(iip1,j,l,iiq) = pdqfi(1,j,l,iq)
+               pdqfi(iip1,j,l,iq) = pdqfi(1,j,l,itr)
             ENDDO
          ENDDO
Index: /LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F
===================================================================
--- /LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F	(revision 4055)
+++ /LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F	(revision 4056)
@@ -45,5 +45,5 @@
       USE Times
 #endif
-      USE infotrac, ONLY: nqtot, niadv, tracers
+      USE infotrac, ONLY: nqtot, tracers
       USE control_mod, ONLY: planet_type, nsplit_phys
 #ifdef CPP_PHYS
@@ -154,5 +154,5 @@
 c    -----------------
 
-      INTEGER i,j,l,ig0,ig,iq,iiq
+      INTEGER i,j,l,ig0,ig,iq,itr
       REAL,ALLOCATABLE,SAVE :: zpsrf(:)
       REAL,ALLOCATABLE,SAVE :: zplev(:,:),zplay(:,:)
@@ -366,6 +366,8 @@
 c
 
+      itr = 0
       DO iq=1,nqtot
-         iiq=niadv(iq)
+         IF(.NOT.tracers(iq)%isAdvected) CYCLE
+         itr = itr + 1
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l=1,llm
@@ -375,5 +377,5 @@
              i=index_i(ig0)
              j=index_j(ig0)
-             zqfi(ig0,l,iq)  = pq(i,j,l,iiq)
+             zqfi(ig0,l,itr)  = pq(i,j,l,iq)
            enddo
          ENDDO
@@ -1069,6 +1071,8 @@
 C
 !cdir NODEP
+      itr = 0
       DO iq=1,nqtot
-         iiq=niadv(iq)
+         IF(.NOT.tracers(iq)%isAdvected) CYCLE
+         itr = itr + 1
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l=1,llm
@@ -1079,11 +1083,11 @@
               i=index_i(ig0)
               j=index_j(ig0)
-              pdqfi(i,j,l,iiq) = zdqfi(ig0,l,iq)
-              if (i==1) pdqfi(iip1,j,l,iiq) = zdqfi(ig0,l,iq)
+              pdqfi(i,j,l,iq) = zdqfi(ig0,l,itr)
+              if (i==1) pdqfi(iip1,j,l,iq) = zdqfi(ig0,l,itr)
             ENDDO
             
             IF (is_north_pole_dyn) then
               DO i=1,iip1
-                pdqfi(i,1,l,iiq)    = zdqfi(1,l,iq)
+                pdqfi(i,1,l,iq)    = zdqfi(1,l,itr)
               ENDDO
             ENDIF
@@ -1091,5 +1095,5 @@
             IF (is_south_pole_dyn) then
               DO i=1,iip1
-                pdqfi(i,jjp1,l,iiq) = zdqfi(klon,l,iq)
+                pdqfi(i,jjp1,l,iq) = zdqfi(klon,l,itr)
               ENDDO
             ENDIF
Index: /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4056)
@@ -17,12 +17,12 @@
   USE vertical_layers_mod, ONLY : init_vertical_layers
   USE infotrac, ONLY: nqtot,nqo,nbtr,nqCO2,tracers,type_trac,&
-                      niadv,conv_flg,pbl_flg,solsym,&
+                      conv_flg,pbl_flg,solsym,&
                       ok_isotopes,ok_iso_verif,ok_isotrac,&
                       ok_init_iso,niso_possibles,tnat,&
                       alpha_ideal,use_iso,iqiso,iso_indnum,&
                       indnum_fn_num,index_trac,&
-                      niso,ntraceurs_zone,ntraciso,nqtottr,itr_indice
+                      niso,ntraceurs_zone,ntraciso,nqtottr
 #ifdef CPP_StratAer
-  USE infotrac, ONLY: nbtr_bin, nbtr_sulgas, id_OCS_strat, &
+  USE infotrac_phy, ONLY: nbtr_bin, nbtr_sulgas, id_OCS_strat, &
                       id_SO2_strat, id_H2SO4_strat, id_BIN01_strat
 
@@ -145,15 +145,10 @@
   ! Initialize tracer names, numbers, etc. for physics
   CALL init_infotrac_phy(nqtot,nqo,nbtr,nqtottr,nqCO2,tracers,type_trac,&
-                         niadv,conv_flg,pbl_flg,solsym,&
+                         conv_flg,pbl_flg,solsym,&
                          ok_isotopes,ok_iso_verif,ok_isotrac,&
                          ok_init_iso,niso_possibles,tnat,&
                          alpha_ideal,use_iso,iqiso,iso_indnum,&
                          indnum_fn_num,index_trac,&
-                         niso,ntraceurs_zone,ntraciso,itr_indice &
-#ifdef CPP_StratAer
-                         ,nbtr_bin,nbtr_sulgas&
-                         ,id_OCS_strat,id_SO2_strat,id_H2SO4_strat,id_BIN01_strat&
-#endif
-                         )
+                         niso,ntraceurs_zone,ntraciso)
 
   ! Initializations for Reprobus
